<template>
  <div class="mb-[12vw] px-[3.735vw]">
    <MChinaHeader :theme-properties="themeProperties" />
    <utils-mobile-banner
      :theme-properties="themeProperties"
      :actived="'HomeInitial'"
      class="mobileBannerCarouselBfm1 home-banner"
    />
    <div v-if="!announcement.IsHidden" class="py-4 bg-background1">
      <div class="container flex flex-col items-center justify-center mx-auto">
        <announcement :announcement="announcement.Text" />
      </div>
    </div>
    <div class="w-full">
      <mini-wallet :auth="auth" />
    </div>
    <div v-if="isRecommendMatchEnabled" class="w-full pt-4">
      <sport-m-popular-match />
    </div>
    <div class="w-full">
      <home-tab :theme-properties="themeProperties" />
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { defineComponent, computed } from "vue";
import MChinaHeader from "./components/Header.client.vue";
import Announcement from "./components/Announment.client.vue";
import MiniWallet from "./components/MiniWallet.client.vue";
import HomeTab from "./components/HomeTab.client.vue";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { gameStore } from "~~/store/game";

export default defineComponent({
  name: "Home",
  components: {
    Announcement,
    MChinaHeader,
    HomeTab,
    MiniWallet,
  },
  setup() {
    const auth = computed(() => store.state.auth);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const sportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_1"
        )
    );
    const virtualSportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_2"
        )
    );
    const casinoBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_3"
        )
    );
    const gamesBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_4"
        )
    );
    const cockFightBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_5"
        )
    );
    const promotionBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_6"
        )
    );
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "announcement"
        )
    );
    const games = computed(() => gameStore.state.games);
    const isSportEnabled = computed(() => {
      const isHidden = sportBanner.value.IsHidden;
      const sportCount = _.filter(
        games.value,
        (item) => item.Category === 1 && item.ForMobile === true
      ).length;
      return !isHidden && sportCount > 0;
    });
    const isVirtualSportEnabled = computed(() => {
      const isHidden = virtualSportBanner.value.IsHidden;
      const virtualSportCount = _.filter(
        games.value,
        (item) => item.Category === 4 && item.ForMobile === true
      ).length;
      return !isHidden && virtualSportCount > 0;
    });
    const isCasinoEnabled = computed(() => {
      const isHidden = casinoBanner.value.IsHidden;
      const casinoCount = _.filter(
        games.value,
        (item) => item.Category === 2 && item.ForMobile === true
      ).length;
      return !isHidden && casinoCount > 0;
    });
    const isGamesEnabled = computed(() => {
      const isHidden = gamesBanner.value.IsHidden;
      return !isHidden;
    });
    const isCockfightEnabled = computed(() => {
      const isHidden = cockFightBanner.value.IsHidden;
      const cockFightCount = _.filter(
        games.value,
        (item) => item.GameProviderId === 46
      ).length;
      return !isHidden && cockFightCount > 0;
    });
    const isPromotionEnabled = computed(() => {
      const isHidden = promotionBanner.value.IsHidden;
      return !isHidden;
    });
    return {
      announcement,
      isSportEnabled,
      isVirtualSportEnabled,
      isCasinoEnabled,
      isGamesEnabled,
      isCockfightEnabled,
      isPromotionEnabled,
      sportBanner,
      virtualSportBanner,
      casinoBanner,
      gamesBanner,
      cockFightBanner,
      promotionBanner,
      isRecommendMatchEnabled,
      themeProperties,
      auth,
    };
  },
});
</script>

<style scoped>
.el-carousel__container {
  height: 125px;
}
:deep(.mobile-banner.home-banner .custom-swiper-mobile) {
  height: unset;
  overflow: hidden;
  border-radius: 8px;
}
:deep(.mobile-banner.home-banner .custom-swiper-mobile .swiper-slide) {
  height: unset;
  overflow: hidden;
  border-radius: 8px;
}
:deep(
    .mobile-banner.home-banner
      .custom-swiper-mobile
      .swiper-slide
      img.object-cover
  ) {
  object-fit: contain;
}
:deep(.mobile-banner.home-banner .custom-swiper-mobile .swiper-slide div) {
  height: unset;
}
:deep(.mobile-banner.home-banner .custom-swiper-mobile .swiper-pagination) {
  top: auto;
  bottom: 18%;
}
:deep(
    .mobile-banner.home-banner
      .custom-swiper-mobile
      .swiper-pagination
      .swiper-pagination-bullet
  ) {
  width: 8px;
  height: 8px;
  border-radius: 50%;
}
</style>
